/********************************** (C) COPYRIGHT *********************************
* File Name          : CH395.C
* Author             : WCH
* Version            : V1.1
* Date               : 2014/8/1
* Description        : CH395
**********************************************************************************/
/* ͷļ*/
#include <reg52.h>
#include <stdio.h>
#include <string.h>
#include "../PUB/CH395INC.H"
#include "CH395.H"
#include "mailinc.h"
/***********************************************************************************/
/*
CH395_OP_INTERFACE_MODEΪ1-5
1Ӳ߲ӷʽ
2ģⲢӷʽ
3: ӲSPIӷʽ
4: ģSPIʽ
5: Ӳ첽ӷʽ
*/
#define   CH395_OP_INTERFACE_MODE             3                      
#if   (CH395_OP_INTERFACE_MODE == 1)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_HW.C"                                           
#elif (CH395_OP_INTERFACE_MODE == 2)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_SW.C"                                            
#elif (CH395_OP_INTERFACE_MODE == 3)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_HW.C"
#elif (CH395_OP_INTERFACE_MODE == 4)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_SW.C"
#elif (CH395_OP_INTERFACE_MODE == 5)                                 /* SEL = 1, TX = 1*/
#include "../PUB/CH395UART.C"
#endif
/***********************************************************************************/

/* ļ */
#include "../PUB/CH395CMD.C"
/**********************************************************************************/

/* ñ */
#define MybufLen  4096                                              /* ch395ݵĻ󳤶 */
UINT8  MyBuffer[2][MybufLen];                                       /* ݻ */
struct _SOCK_INF  SockInf[2];                                       /* SocketϢ */
struct _CH395_SYS CH395Inf;                                         /* CH395Ϣ */
UINT8  tcptimeout_flag;
UINT8  phyDiscont_flag;

/**********************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ룬ͣ
* Input          : iError
* Output         : None
* Return         : None
**********************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CMD_ERR_SUCCESS) return;                          /* ɹ */
    printf("Error: %02X\n", (UINT16)iError);                        /* ʾ */
    while ( 1 ) 
    {
        mDelaymS(200);
        mDelaymS(200);
    }
}

/**********************************************************************************
* Function Name  : CH395CloseSocket
* Description    : رsocket
* Input          : sockindex Socket
* Output         : None
* Return         : ִн
**********************************************************************************/
UINT8  CH395CloseSocketp(UINT8 sockindex)
{
    UINT8 i = 0;
    UINT8 s = 0;
	OrderType = COMMAND_UNUSEFULL;
	CheckType = uncheck;
    xWriteCH395Cmd(CMD1W_CLOSE_SOCKET_SN);
    xWriteCH395Data(sockindex);
    xEndCH395Cmd();
    while(1)
    {
        mDelaymS(5);                                                 /* ʱѯ2MS*/
        s = CH395GetCmdStatus();                                     /* ܹƵѯ*/
        if(s !=CH395_ERR_BUSY)break;                                 /* CH395оƬæ״̬*/
        if(i++ > 200)return CH395_ERR_UNKNOW;                        /* ʱ˳*/
    }
    return s;
}

/**********************************************************************************
* Function Name  : InitCH395InfParam
* Description    : ʼCH395Inf
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitCH395InfParam(void)
{
    memset(&CH395Inf,0,sizeof(CH395Inf));                            /* CH395Infȫ*/
    memcpy(CH395Inf.IPAddr,CH395IPAddr,sizeof(CH395IPAddr));         /* IPַдCH395Inf */
    memcpy(CH395Inf.GWIPAddr,CH395GWIPAddr,sizeof(CH395GWIPAddr));   /* IPַдCH395Inf */
    memcpy(CH395Inf.MASKAddr,CH395IPMask,sizeof(CH395IPMask));       /* дCH395Inf */
}

/*********************************************************************************
* Function Name  : InitSocketParam
* Description    : ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitSocketParam( )
{
  memset(&SockInf[0],0,sizeof(SockInf[0]));                         /* SockInf[0]ȫ*/
  memcpy(SockInf[0].IPAddr,Socket0DesIP,sizeof(Socket0DesIP));      /* ĿIPַд */
  SockInf[0].DesPort = Socket0DesPort;                              /* ĿĶ˿ */
  SockInf[0].SourPort = Socket0SourPort;                            /* Դ˿ */
  SockInf[0].ProtoType = PROTO_TYPE_TCP;                            /* UDPģʽ */
  SockInf[0].TcpMode = TCP_CLIENT_MODE;                             /* TCPģʽ */

  memset(&SockInf[1],0,sizeof(SockInf[1]));                         /* SockInf[1]ȫ*/
  memcpy(SockInf[1].IPAddr,Socket1DesIP,sizeof(Socket1DesIP));      /* ĿIPַд */
  SockInf[1].DesPort = Socket1DesPort;                              /* ĿĶ˿ */
  SockInf[1].SourPort = Socket1SourPort;                            /* Դ˿ */
  SockInf[1].ProtoType = PROTO_TYPE_TCP;                            /* TCPģʽ */
  SockInf[1].TcpMode = TCP_CLIENT_MODE;                             /* TCPģʽ */
}

/**********************************************************************************
* Function Name  : CH395SocketInitOpen
* Description    : CH395 socket ʼsocket
* Input          : index
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInitOpen(UINT8 index)
{
    UINT8 i;
    /* socket indexΪTCP ͻģʽ */
    memset( MyBuffer[index], '\0', sizeof(MyBuffer[index]) );
    if( index == SendSocket ) CheckType = SMTP_CHECK_CNNT;
    if( index == ReceSocket ) CheckType = POP_CHECK_CNNT;
    CH395SetSocketDesIP(index,SockInf[index].IPAddr);                /* socket 0ĿIPַ */         
    CH395SetSocketProtType(index,SockInf[index].ProtoType);          /* socket 0Э */
    CH395SetSocketDesPort(index,SockInf[index].DesPort);             /* socket 0ĿĶ˿ */
    CH395SetSocketSourPort(index,SockInf[index].SourPort);           /* socket 0Դ˿ */
    i = CH395OpenSocket(index);                                      /* socket   */
    mStopIfError(i);                                                 /* Ƿɹ */
    i = CH395TCPConnect(index);                                      /* TCP      */
    mStopIfError(i);                                                 /* Ƿɹ */
}

/*********************************************************************************
* Function Name  : CH395SocketInterrupt
* Description    : CH395 socket ж,ȫжб
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInterrupt(UINT8 sockindex)
{
   char    check=0;  
   UINT8  sock_int_socket;
   UINT8  i;
   UINT16 len;
   sock_int_socket = CH395GetSocketInt(sockindex);                   /* ȡsocket ж״̬ */
   if(sock_int_socket & SINT_STAT_SENBUF_FREE)                       /* ͻУԼдҪ͵ */
   {
   }
   if(sock_int_socket & SINT_STAT_SEND_OK)                           /* ж */
   {
     if(sockindex == SendSocket) SendDatFalg = 1;
   }
   if(sock_int_socket & SINT_STAT_RECV)                              /* ж */
   {
       ReceDatFlag = 1;
       len = CH395GetRecvLength(sockindex);                          /* ȡǰݳ */
       if(len == 0)return;
       if(len>MybufLen) len = MybufLen;
       CH395GetRecvData(sockindex,len,MyBuffer[sockindex]);          /* ȡ */
       SockInf[sockindex].RemLen = len;                              /* 泤 */
       ReceLen = len; 
#if  DEBUG
     printf("ReceLen= %04x\n",ReceLen);
     printf("CheckType= %02x\n",(UINT16)CheckType);
     printf("MyBuffer = %s\n",MyBuffer[sockindex]);
#endif
     if(CheckType != uncheck){
       i = ch395mail_CheckResponse(MyBuffer[sockindex],CheckType);
       if(i != CHECK_SUCCESS){
            if(sockindex == SendSocket) OrderType = SMTP_ERR_CHECK;
            if(sockindex == ReceSocket) OrderType = POP_ERR_CHECK;
#if  DEBUG
  printf("ERROR: %02x\n",(UINT16)i);
#endif
          }
     }     
  }
   if(sock_int_socket & SINT_STAT_CONNECT)                          /* жϣTCPģʽЧ*/
   {
#if  DEBUG
     printf("Tcp Connect\n");
#endif
   }
   if(sock_int_socket & SINT_STAT_DISCONNECT)                        /* ϿжϣTCPģʽЧ */
   {
   }
   if(sock_int_socket & SINT_STAT_TIM_OUT)                           /* ʱжϣTCPģʽЧ */
   {
#if  DEBUG
      printf("Tcp Time out\n");
#endif
       tcptimeout_flag = 1;
       /* ʱжϱʾ//ݳʱʧܣʱʱCH395оƬڲὫ    */
       /* socketرգĳЩCH395ӣԶ˶˿δ򿪣CH395ӣ */
       /* Զ豸ܻᷢRSTǿƽӸλʱCH395Ȼʱжϡʾ */
       /* ʵӦвƼʱжϺӣԼһʱ´socket */
       /* ɡ*/         
       if(SockInf[sockindex].TcpMode  == TCP_CLIENT_MODE)                       
       {
           mDelaymS(200);                                            /* ʱ200MSٴԣûбҪƵ */
           i = CH395OpenSocket(sockindex);
           mStopIfError(i);
           CH395TCPConnect(sockindex);                               /* ʼ */
           mStopIfError(i);
      }
   }
}

/*********************************************************************************
* Function Name  : CH395GlobalInterrupt
* Description    : CH395ȫжϺ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395GlobalInterrupt(void) 
{
   UINT16  init_status;
   UINT16 i;
   UINT8  buf[10]; 
 
    init_status = CH395CMDGetGlobIntStatus_ALL();
    if(init_status & GINT_STAT_UNREACH)                              /* ɴжϣȡɴϢ */
    {
        CH395CMDGetUnreachIPPT(buf);                                
    }
    if(init_status & GINT_STAT_IP_CONFLI)                            /* IPͻжϣ޸CH395 IPʼCH395*/
    {
    }
    if(init_status & GINT_STAT_PHY_CHANGE)                           /* PHYıж*/
    {
#if  DEBUG
        printf("Init status : GINT_STAT_PHY_CHANGE\n");
#endif
        i = CH395CMDGetPHYStatus();                                  /* ȡPHY״̬ */
        if(i == PHY_DISCONN){
        phyDiscont_flag = 1;
#if  DEBUG
      printf("Ethernet Disconnect\n");                               /* PHY_DISCONNCH395ڲԶرеsocket*/
#endif
    }
    }
    if(init_status & GINT_STAT_SOCK0)
    {
    CH395SocketInterrupt(0);                                         /* socket 0ж*/
    }
    if(init_status & GINT_STAT_SOCK1)                                
    {
        CH395SocketInterrupt(1);                                     /* socket 1ж*/
    }
    if(init_status & GINT_STAT_SOCK2)
    {
        CH395SocketInterrupt(2);                                     /* socket 2ж*/
    }
    if(init_status & GINT_STAT_SOCK3)                                
    {
        CH395SocketInterrupt(3);                                     /* socket 3ж*/
    }
    if(init_status & GINT_STAT_SOCK4)
    {
         CH395SocketInterrupt(4);                                    /* socket 4ж*/
    }
    if(init_status & GINT_STAT_SOCK5)                                
    {
        CH395SocketInterrupt(5);                                     /* socket 5ж*/
    }
    if(init_status & GINT_STAT_SOCK6)
    {
        CH395SocketInterrupt(6);                                     /* socket 6ж*/
    }
    if(init_status & GINT_STAT_SOCK7)                                
    {
        CH395SocketInterrupt(7);                                     /* socket 7ж*/
    }

}

/*********************************************************************************
* Function Name  : CH395Init
* Description    : CH395IP,GWIP,MACȲʼ
* Input          : None
* Output         : None
* Return         : ִн
**********************************************************************************/
UINT8  CH395Init(void)
{
    UINT8 i;
    
    i = CH395CMDCheckExist(0x65);   
	printf("check ======%2x\n",(UINT16)i);                   
    if(i != 0x9a)return CH395_ERR_UNKNOW;                            /* ޷ͨ0XFA */
                                                                     /* 0XFAһΪӲ߶дʱ򲻶 */
#if (CH395_OP_INTERFACE_MODE == 5)                                   
#ifdef UART_WORK_BAUDRATE
    CH395CMDSetUartBaudRate(UART_WORK_BAUDRATE);                     /* ò */   
    mDelaymS(1);
    SetMCUBaudRate();
    i = xReadCH395Data();                                            /* óɹCH395CMD_ERR_SUCCESS */
    if(i == CMD_ERR_SUCCESS)printf("Set Success\n");
#endif
#endif
    CH395CMDSetIPAddr(CH395Inf.IPAddr);                              /* CH395IPַ */
    CH395CMDSetGWIPAddr(CH395Inf.GWIPAddr);                          /* صַ */
    CH395CMDSetMASKAddr(CH395Inf.MASKAddr);                          /* 룬ĬΪ255.255.255.0*/   
    i = CH395CMDInitCH395();                                         /* ʼCH395оƬ */
    return i;
}

/**********************************************************************************
* Function Name  : mInitSTDIO
* Description    : ڳʼ,ʹ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void mInitSTDIO( void )
{
    SCON = 0x50;
    PCON = 0x80;
    TMOD = 0x21;
    TH1 = 0xf3;                                                      /* 24MHz, 9600bps */
    TR1 = 1;
    TI = 1;
}
/*********************************************************************************
* Function Name  : SendData
* Description    : 
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
UINT8 ch395mail_SendData( UINT8 *PSend, UINT16 Len,UINT8 type,UINT8 index  )
{
  UINT16  count;
  CheckType = type;
  memset( MyBuffer[index], '\0', sizeof(MyBuffer[index]) );
  CH395SendData(index,PSend,Len);
  SendDatFalg = 0;
  phyDiscont_flag = 0;
  tcptimeout_flag = 0;
  count = 0;
  if(CheckType == uncheck){
    while(SendDatFalg==0){
      if(CH395_INT_WIRE == 0)  CH395GlobalInterrupt();
      if( phyDiscont_flag ){
        OrderType = COMMAND_UNUSEFULL; 
        return 0;
      } 
      if( tcptimeout_flag ){
        OrderType = COMMAND_UNUSEFULL; 
        return 0;
      }
      mDelaymS(1);
      count++;
      if(count>10000){
#if DEBUG
        printf("wait send Mail Header timeout\n");
#endif
        OrderType = SMTP_ERR_CHECK;
        return send_data_timeout;
      }
    }
    return send_data_success; 
  }
    return send_data_success; 
}

/*********************************************************************************
* Function Name  : main
* Description    : main
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void ch395mail( )
{
  UINT8 i;
  
  ReceDatFlag = 0;
  mDelaymS(100);
  mInitSTDIO();                                                      /* ʱ100 */
#if  DEBUG
  printf("start:\n");
#endif
  CH395_PORT_INIT();
  InitCH395InfParam();                                               /* ʼCH395ر */
  i = CH395Init();                                                   /* ʼCH395оƬ */
  mStopIfError(i);
  while(1)
  {                                                                  /* ȴ̫ӳɹ*/
     if(CH395CMDGetPHYStatus() == PHY_DISCONN)                       /* ѯCH395Ƿ */
     {
         mDelaymS(200);                                              /* δȴ200MSٴβѯ */
     }
     else 
     {
#if  DEBUG
         printf("Connect Ethernet\n");                               /* CH395оƬӵ̫ʱж */
#endif
         break;
     }
  }
  InitSocketParam( );                                                /* ʼsocketر */
}

